<template>
  <div v-if="event && user">
    <PageTemplate type="event" :data="event" />
    <el-upload
      v-if="event.user_id === user.id"
      :id="$route.params.id"
      where="event"
      multiple
    />
    <Feed
      v-if="media.length"
      v-loading="loading"
      :data="media"
      :counter="true"
      :moderate="event.user_id === user.id ? true : false"
      type="event"
    />
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  ref,
  computed,
  useMeta
} from '@nuxtjs/composition-api'
import { useGetEventQuery, useMediaSubscription } from '@/sdk/hooks'
import { EventFragment, MediaFileFragment } from '@/sdk/types'

import useAddPayment from '@/hooks/add-payment'

import PageTemplate from '@/components/template/PrivatePage.vue'
import elUpload from '@/components/element/Upload.vue'

import Feed from '@/components/ui/Feed.vue'

export default defineComponent({
  name: 'PrivateEventPage',
  components: {
    PageTemplate,
    elUpload,
    Feed
  },
  head: {},
  setup(_, { root }) {
    const { app } = useContext()
    const meta = useMeta()

    const user = computed(() => root.$accessor.auth.user)
    const event = ref<EventFragment>([] as any)
    const { onResult } = useGetEventQuery({
      id: root.$route.params.id as string
    })
    if (process.client) {
      onResult(result => {
        if (result?.data?.event) {
          event.value = result.data.event
          meta.title.value =
            event.value?.name + ' by ' + event.value?.user.display_name
          meta.meta.value = [
            {
              hid: 'description',
              name: 'description',
              content: event.value?.comment
            }
          ]
        }
      })
    }

    // upload photos && output media
    const media = ref<MediaFileFragment[]>([])
    const { onResult: mediaResult, loading } = useMediaSubscription(
      computed(() => ({
        where: {
          event_id: { _eq: root.$route.params.id }
        },
        limit: 2000,
        offset: 0
      }))
    )
    mediaResult(result => {
      if (result?.data?.media_files) {
        media.value = result.data.media_files
      }
    })

    // media
    const onUploadPhoto = async (file: File) => {
      try {
        await app.$api.storage.upload(
          `public/web/media/${Date.now()}.jpg`,
          file,
          {
            type: 'event',
            object_id: root.$route.params.id
          }
        )
      } catch (e) {
        root.$message({
          message: 'Sorry, something wrong 😩',
          type: 'error'
        })
      } finally {
        root.$message({
          message: 'Success 👌',
          type: 'success'
        })
      }
    }

    return {
      user,
      event,

      loading,
      media,
      onUploadPhoto,

      useAddPayment
    }
  }
})
</script>
